# -*- coding: utf-8 -*-

import re
import urllib2

def download_page(url):
    "Faz o download da página especificada pela URL e a devolve."
    response = urllib2.urlopen(url)
    return response.read()

def crawler():
    "Faz o download de todas as páginas do website do projeto Arquigrafia e\
    devolve uma lista de dicionários contendo as informações de cada foto."
    fotos = []
    for i in range(1, 3701):
        try:
            html = download_page('http://www.arquigrafia.org.br/photo/%s' % i)
        except urllib2.HTTPError:
            continue
        titulo = re.findall(r'<h1>(.*?)</h1>', html, re.DOTALL)
        descricao = re.findall(r'<h3>Descrição:</h3>\s+<p>(.*?)</p>', html, re.DOTALL)
        colecao = re.findall(r'<h3>Coleção:</h3>\s+<p>(.*?)</p>', html, re.DOTALL)
        data_de_upload = re.findall(r'<h3>Data de Upload:</h3>\s+<p>(.*?)</p>', html, re.DOTALL)
        data_da_imagem = re.findall(r'<h3>Data da Imagem:</h3>\s+<p>(.*?)</p>', html, re.DOTALL)
        autor_da_imagem = re.findall(r'<h3>Autor da Imagem:</h3>\s+<p>\s+<a href="[^"]*">\s+(.*?)\s+</a>\s+</p>', html, re.DOTALL)
        autor_da_obra = re.findall(r'<h3>Autor da Obra:</h3>\s+<p>\s+<a href="[^"]*">\s+(.*?)\s+</a>\s+</p>', html, re.DOTALL)
        data_da_obra = re.findall(r'<h3>Data da Obra:</h3>\s+<p>(.*?)</p>', html, re.DOTALL)
        rua = re.findall(r'street = "(.*?)";', html, re.DOTALL)
        distrito = re.findall(r'district = "(.*?)";', html, re.DOTALL)
        cidade = re.findall(r'city = "(.*?)";', html, re.DOTALL)
        estado = re.findall(r'state = "(.*?)";', html, re.DOTALL)
        pais = re.findall(r'country = "(.*?)";', html, re.DOTALL)
        fotos.append({
            'titulo': titulo[0] if titulo else '',
            'imagem': 'http://www.arquigrafia.org.br/photo/img-show/%s.jpeg' % i,
            'descricao': descricao[0] if descricao else '',
            'colecao': colecao[0] if colecao else '',
            'data_de_upload': data_de_upload[0] if data_de_upload else '',
            'data_da_imagem': data_da_imagem[0] if data_da_imagem else '',
            'autor_da_imagem': autor_da_imagem[0] if autor_da_imagem else '',
            'autor_da_obra': autor_da_obra[0] if autor_da_obra else '',
            'data_da_obra': data_da_obra[0] if data_da_obra else '',
            'rua': rua[0] if rua else '',
            'distrito': distrito[0] if distrito else '',
            'cidade': cidade[0] if cidade else '',
            'estado': estado[0] if estado else '',
            'pais': pais[0] if pais else '',
            'tags': re.findall(r'<a class="" href="[^"]*" >(.*?)</a>', html, re.DOTALL)
        })
    return fotos

def main():
    "Imprime o crawler dos dados do projeto Arquigrafia em formato CSV na saída padrão."
    print u'Título,Imagem,Descrição,Coleção,Data de upload,Data da imagem,Autor da imagem,Autor da obra,Data da obra,Rua,Distrito,Cidade,Estado,País,Tags'.encode('utf-8')
    for foto in crawler():
        print '"%s",%s,"%s","%s","%s","%s","%s","%s","%s","%s","%s","%s","%s","%s","%s"' % (foto['titulo'].replace('"', '""'),
                                                                                            foto['imagem'],
                                                                                            foto['descricao'].replace('"', '""'),
                                                                                            foto['colecao'].replace('"', '""'),
                                                                                            foto['data_de_upload'].replace('"', '""'),
                                                                                            foto['data_da_imagem'].replace('"', '""'),
                                                                                            foto['autor_da_imagem'].replace('"', '""'),
                                                                                            foto['autor_da_obra'].replace('"', '""'),
                                                                                            foto['data_da_obra'].replace('"', '""'),
                                                                                            foto['rua'].replace('"', '""'),
                                                                                            foto['distrito'].replace('"', '""'),
                                                                                            foto['cidade'].replace('"', '""'),
                                                                                            foto['estado'].replace('"', '""'),
                                                                                            foto['pais'].replace('"', '""'),
                                                                                            ','.join(foto['tags']).replace('"', '""')) 
if __name__ == '__main__':
    main()
