# -*- coding: utf-8 -*-

from django.db import models

class Tag(models.Model):
    nome = models.CharField(max_length=256, unique=True)

    def __unicode__(self):
        return self.nome

class Foto(models.Model):
    titulo = models.CharField(blank=True, verbose_name=u'Título',
                              max_length=1024)
    arquivo = models.CharField(blank=True, max_length=256)
    descricao = models.TextField(blank=True, verbose_name=u'Descrição')
    colecao = models.CharField(blank=True, verbose_name=u'Coleção',
                               max_length=512)
    data_de_upload = models.CharField(blank=True, max_length=128)
    data_da_imagem = models.CharField(blank=True, max_length=128)
    autor_da_imagem = models.CharField(blank=True, max_length=512)
    autor_da_obra = models.CharField(blank=True, max_length=512)
    data_da_obra = models.CharField(blank=True, max_length=128)
    rua = models.CharField(blank=True, max_length=2048)
    distrito = models.CharField(blank=True, max_length=1024)
    cidade = models.CharField(blank=True, max_length=1024)
    estado = models.CharField(blank=True, max_length=64)
    pais = models.CharField(blank=True, verbose_name=u'País', max_length=128)
    tags = models.ManyToManyField(Tag, blank=True, related_name='fotos')
    visto_da_rua = models.CharField(
        verbose_name=u'É visto da Rua?',
        max_length=16,
        choices=(
            ('indefinido', 'Indefinido'),
            ('nao', u'Não'),
            ('sim', 'Sim'),
        ),
        default='indefinido',
    )
    endereco_completo = models.CharField(
        verbose_name=u'Tem endereço completo?',
        max_length=16,
        choices=(
            ('indefinido', 'Indefinido'),
            ('nao', u'Não'),
            ('sim', 'Sim'),
        ),
        default='indefinido',
    )
    latitude = models.CharField(max_length=32)
    longitude = models.CharField(max_length=32)
    posicao_correta = models.NullBooleanField(
        verbose_name=u'A posição está correta?'
    )

    def __unicode__(self):
        return self.titulo
