# -*- coding: utf-8 -*-

from django.core.management import setup_environ
from website import settings
setup_environ(settings)

import csv
import sys
import urllib2
from arquigrafia.models import Foto, Tag

def main():
    "Lê um arquivo CSV na entrada e insere as tuplas no banco de dados da aplicação Django."
    if len(sys.argv) != 2:
        print u'Insira o nome de um arquivo CSV como parâmetro na entrada.'
    with open(sys.argv[1], 'rb') as input:
        reader = csv.reader(input)
        header = True
        for row in reader:
            if header is True:
                header = False
            else:
                foto = Foto.objects.create(
                    titulo=row[0],
                    arquivo=row[1],
                    descricao=row[2],
                    colecao=row[3],
                    data_de_upload=row[4],
                    data_da_imagem=row[5],
                    autor_da_imagem=row[6],
                    autor_da_obra=row[7],
                    data_da_obra=row[8],
                    rua=row[9],
                    distrito=row[10],
                    cidade=row[11],
                    estado=row[12],
                    pais=row[13]
                )
                for nome in row[14].split(','):
                    tag, created = Tag.objects.get_or_create(nome=nome)
                    foto.tags.add(tag)

if __name__ == '__main__':
    main()
