# -*- coding: utf-8 -*-

from django.core.management import setup_environ
from website import settings
setup_environ(settings)

from arquigrafia.models import Foto
from api.navigation import Point

def main():
    """Verifica se os enderecos do projeto Arquigrafia sao completos e
    identificaveis pela API Google Geocoding.
    
    """
    for foto in Foto.objects.all():
        if foto.rua and foto.cidade and foto.estado:
            if ' esq' in foto.rua.lower() or \
               ' com ' in foto.rua.lower() or \
               foto.rua.lower().startswith('rodovia') or \
               foto.rua.lower().startswith('bloco'):
                foto.endereco_completo = 'nao'
            else:
                foto.endereco_completo = 'sim'
        else:
            foto.endereco_completo = 'nao'
        foto.save()

if __name__ == '__main__':
    main()
