import os
import urllib2
import sys

from api.navigation import Route, Point

KEY = 'AIzaSyCIIdJRlM8Iu_ldTW4j9HdqRsSUhL0H5GQ'
HELP_TEXT = """
    Usage: python save_route.py <dirname> <maximum_distance_between_points>
    <camera_heading> <camera_pitch> <width> <height>

    dirname -- Directory to save image files.

    maximum_distance_between_points -- Maximum distance between route points in
    meters.

    camera_heading -- Heading of camera relative to vehicle.

    camera_pitch -- Pitch of camera.

    width -- Width of images.

    height -- Height of images.
"""

def main():
    try:
        dirname = sys.argv[1]
        maximum_distance_between_points = int(sys.argv[2])
        camera_heading = int(sys.argv[3])
        camera_pitch = int(sys.argv[4])
        width = int(sys.argv[5])
        height = int(sys.argv[6])
    except:
        print HELP_TEXT
        return -1
    origin = raw_input('Digite a origem: ')
    origin_point = Point.for_address(origin)
    destination = raw_input('Digite o destino: ')
    destination_point = Point.for_address(destination)
    route = Route.between(origin_point, destination_point,
                          maximum_distance_between_points)
    if not os.path.exists(dirname):
        os.makedirs(dirname)
    for i, image in \
        enumerate(route.google_street_view_images(camera_heading,
                                                  camera_pitch, width, height)):
        response = urllib2.urlopen(image.url(KEY))
        if response.getcode() != 200:
            raise Exception
        imgfile = open('%s/%s.png' % (dirname, i), 'wb')
        imgfile.write(response.read())
        imgfile.close()

if __name__ == '__main__':
    main()
